"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const client_1 = require("@deep-foundation/hasura/client");
const client_2 = require("../imports/client");
const chai_1 = require("chai");
const adminToken = `eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJodHRwczovL2hhc3VyYS5pby9qd3QvY2xhaW1zIjp7IngtaGFzdXJhLWFsbG93ZWQtcm9sZXMiOlsibGluayJdLCJ4LWhhc3VyYS1kZWZhdWx0LXJvbGUiOiJsaW5rIiwieC1oYXN1cmEtdXNlci1pZCI6IjI0In0sImlhdCI6MTY0MDM5MDY1N30.l8BHkbl0ne3yshcF73rgPVR-Sskr0hHECr_ZsJyCdxA`;
const apolloClient = (0, client_1.generateApolloClient)({
    path: `${process.env.HASURA_PATH}/v1/graphql`,
    ssl: !!+process.env.HASURA_SSL,
    token: adminToken,
});
const deep = new client_2.DeepClient({ apolloClient });
describe('permissions', () => {
    describe('select', () => {
        it(`user contain range`, () => __awaiter(void 0, void 0, void 0, function* () {
            const a1 = yield deep.guest({});
            const a2 = yield deep.guest({});
            const d1 = new client_2.DeepClient(Object.assign({ deep }, a1));
            const d2 = new client_2.DeepClient(Object.assign({ deep }, a2));
            const { data: [{ id }] } = yield deep.insert({
                type_id: yield deep.id('@deep-foundation/core', 'SyncTextFile'),
                in: { data: {
                        type_id: yield deep.id('@deep-foundation/core', 'Contain'),
                        from_id: a1.linkId,
                    } }
            });
            const n1 = yield d1.select({ id });
            chai_1.assert.lengthOf(n1 === null || n1 === void 0 ? void 0 : n1.data, 1);
            const n2 = yield d2.select({ id });
            chai_1.assert.lengthOf(n2 === null || n2 === void 0 ? void 0 : n2.data, 0);
        }));
    });
    describe('insert', () => {
    });
});
//# sourceMappingURL=permissions.js.map